package com.filleduchaos.media_library

import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

class MediaLibraryPlugin(private val registrar: Registrar): MethodCallHandler {
  companion object {
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "@filleduchaos/media_library")
      channel.setMethodCallHandler(MediaLibraryPlugin(registrar))
    }
  }

  private val library = MediaLibrary(registrar)

  override fun onMethodCall(call: MethodCall, result: Result) {
    when (call.method) {
      "executeQuery" -> result.success(library.executeQuery(call.arguments as Map<String, Any>))
      "loadImage" -> result.success(library.loadImage(call.arguments as String))
      else -> result.notImplemented()
    }
  }
}
