part of media_library;

const kMediaLibraryChannelName = '@filleduchaos/media_library';

String _wrap(dynamic text) => "$kMediaLibraryChannelName: $text";

class _Channel {
  static const MethodChannel _channel = const MethodChannel(kMediaLibraryChannelName);

  static Future<T> call<T>(String method, dynamic arguments) async {
    try {
      return (await _channel.invokeMethod(method, arguments)) as T;
    }
    on PlatformException catch (e, st) {
      print(_wrap(e));
      debugPrint(st.toString());
      throw e;
    }
  }
}
