part of media_library;

enum MediaType {
  image
}

abstract class Media {
  final String id;
  final DateTime addedAt;
  final DateTime modifiedAt;

  Media({ this.id, this.addedAt, this.modifiedAt });
}

class ImageMedia extends Media {
  final double latitude;
  final double longitude;
  final int width;
  final int height;
  final String path;

  ImageMedia({ String id, this.path, this.latitude, this.longitude, this.width, this.height, DateTime addedAt, DateTime modifiedAt })
    : super(id: id, addedAt: addedAt, modifiedAt: modifiedAt);

  factory ImageMedia._fromJson(Map json) {
    final addedAt = json["addedAt"] != null ? DateTime.fromMillisecondsSinceEpoch(json["addedAt"] as int) : null;
    final modifiedAt = json["modifiedAt"] != null ? DateTime.fromMillisecondsSinceEpoch(json["modifiedAt"] as int) : null;

    return ImageMedia(
      id: json["id"] as String,
      path: json["path"] as String,
      latitude: json["latitude"] as double,
      longitude: json["longitude"] as double,
      width: json["width"] as int,
      height: json["height"] as int,
      addedAt: addedAt,
      modifiedAt: modifiedAt,
    );
  }

  Future<Uint8List> load() => _Channel.call<Uint8List>("loadImage", id);
}
