part of media_library;

class LibraryImage extends StatefulWidget {
  final ImageMedia asset;
  final BoxFit fit;

  LibraryImage({ Key key, @required this.asset, this.fit }): super(key: key);

  @override
  operator ==(other) {
    return (other is LibraryImage && other.asset.id == asset.id && other.fit == fit);
  }

  @override
  int get hashCode => hashValues(asset.id, fit);

  @override
  _LibraryImageState createState() => _LibraryImageState();
}

class _LibraryImageState extends State<LibraryImage> {
  File _file;
  Future<Uint8List> _bytes;

  @override
  void initState() {
    super.initState();
    if (widget.asset.path != null) {
      _file = File(widget.asset.path);
    }
    else {
      _bytes = widget.asset.load();
    }
  }

  @override
  Widget build(BuildContext context) {
    if (_file != null) {
      return Image.file(_file, fit: widget.fit);
    }

    return FutureBuilder<Uint8List>(
      future: _bytes,
      builder: (context, snapshot) {
        if (snapshot.hasData) return Image.memory(snapshot.data, fit: BoxFit.contain);

        return Center(child: CircularProgressIndicator());
      },
    );
  }
}
